#ifndef IZ_WSCLIENT_H
#define IZ_WSCLIENT_H

#include <libwebsockets.h>
#include "../IZ_common.h"
#include "IZ_websocket.h"

typedef struct {
	struct lws_context *context;
	struct lws_vhost *vhost;
	const struct lws_protocols *protocol;

	lws_sorted_usec_list_t sul;

	struct lws_ring *ring; /* ringbuffer holding unsent messages */
	u32 tail;

	struct lws_client_connect_info i;
	struct lws *client_wsi;

	u8 finished: 1;
	u8 established: 1;
	const char* address;
	const char* path;
	u16* port;
} IZ_WSClientVHostData;

typedef struct {
	struct lws_ring *ring;
	u32 tail;
	char flow_controlled;
	u8 completed: 1;
	u8 write_consume_pending: 1;
} IZ_WSClientSessionData;

typedef struct {
	const char* address;
	const char* path;
	u16 port;
} IZ_WSClientInitializeParams;

typedef struct {
	IZ_Websocket ws;
} IZ_WSClientState;

IZ_ProcedureResult IZ_WSClientInitialize(IZ_WSClientState*, IZ_WSClientInitializeParams);

IZ_ProcedureResult IZ_WSClientHandle(IZ_WSClientState*);

void IZ_WSClientTeardown(IZ_WSClientState*);

void IZ_WSClientCancelService(IZ_WSClientState*);

#endif
