#include "../../../__mocks__/minIni.mock.h"
#include "../../../__mocks__/SDL_stdinc.mock.h"
#include "../../../__mocks__/SDL_render.mock.h"
#include "IZ_video.h"

spec("output") {
	describe("video") {
		describe("SaveConfig") {
			static IZ_VideoConfig config;

			after_each() {
				mock_reset(ini_putl);
			}

			before_each() {
				config.width = 1337;
				config.height = 420;
				config.max_fps = 69;
			}

			it("calls save method") {
				mock_set_expected_calls(ini_putl, 3);

				IZ_VideoSaveConfig(&config, "config.ini");

				check(
					mock_get_expected_calls(ini_putl) == mock_get_actual_calls(ini_putl),
					"Call count mismatch for ini_putl() (expected %u, received %u).",
					mock_get_expected_calls(ini_putl),
					mock_get_actual_calls(ini_putl)
				);
			}
		}
	}
}
