#ifndef IZ_APP_H
#define IZ_APP_H

#include <signal.h>
#include <stdbool.h>
#include "network/IZ_wsserver.h"
#include "log/IZ_log.h"
#include "IZ_common.h"

typedef struct {
	i32 log_level;
	u16 port;
} IZ_AppConfig;

typedef struct {
	IZ_AppConfig config;
	IZ_WSServerState server;
} IZ_App;

static const IZ_App IZ_APP_DEFAULT_STATE = {
	.config = {
		.log_level = LLL_USER | LLL_ERR | LLL_WARN | LLL_NOTICE,
		.port = 42069,
	},
};

static IZ_App global_app;

IZ_ProcedureResult IZ_AppRun(IZ_App*, u8, const char**);

#endif
